--[[Author:		Cyprias 
	License:	All Rights Reserved
	Contact:	Cyprias on Curse.com or WowAce.com

	Only Curse.com and Wowace.com have permission to host this addon.
	I have not given permission for Totem Radius to be used in any addon compilation or UI pack.]]
local  _, class  = UnitClass('player')
if class ~= 'SHAMAN' then
	return
end
	
	
-- global lookup
local pairs_ 								= pairs
local InterfaceOptionsFrame_OpenToCategory_	= InterfaceOptionsFrame_OpenToCategory



local GetTotemInfo_							= GetTotemInfo
local select_ 								= select
local Minimap_
local CreateFrame_ 							= CreateFrame
local unpack_ 								= unpack
local GetCVar_ 								= GetCVar
local math_deg = math.deg
local math_atan2 = math.atan2
local GetPlayerMapPosition_ = GetPlayerMapPosition


local folder, core = ...
TR = core --global table

-- Isolate the environment
local _G = getfenv(0)
setmetatable(TR, {__index = _G})
setfenv(1, TR)
-- local
title		= "Totem Radius"
version		= GetAddOnMetadata(folder, "X-Curse-Packaged-Version") or ""
titleFull	= title.." "..version

LibStub("AceAddon-3.0"):NewAddon(core, folder, "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "AceHook-3.0") 

Astrolabe = DongleStub("Astrolabe-0.4")



local regEvents = {
	"PLAYER_TOTEM_UPDATE",
	"MINIMAP_UPDATE_ZOOM",
--~ 	"UNIT_AURA",
}
db	= {}
P	= {} --db.profile

defaultSettings	= {
	profile = {
		totemColour= {},
	},
}

function core:OnInitialize()
	db = LibStub("AceDB-3.0"):New("TR_DB", defaultSettings)
	CoreOptionsTable.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(db)--save option profile or load another chars opts.
	db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	db.RegisterCallback(self, "OnProfileDeleted", "OnProfileChanged")
	self:RegisterChatCommand("tr", "MySlashProcessorFunc")
	
	
	local config = LibStub("AceConfig-3.0")
	local dialog = LibStub("AceConfigDialog-3.0")
	config:RegisterOptionsTable(title, CoreOptionsTable)
	coreOpts = dialog:AddToBlizOptions(title, titleFull)
	
	Minimap_ = _G.Minimap
end

function core:OnEnable()
	P = db.profile
--~ 	fR = db.factionrealm
--~ 	G = db.global
	
	for i, event in pairs_(regEvents) do 
		self:RegisterEvent(event)
	end

--~ 	CreateOurFrames()

	self:SecureHook(Minimap_, "SetZoom", "Minimap_SetZoom")
end

function core:OnDisable()

end

----------------------------------------------------------------------
function core:OnProfileChanged(...)									--
-- User has reset proflie, so we reset our spell exists options.	--
----------------------------------------------------------------------
	-- Shut down anything left from previous settings
	self:Disable()
	-- Enable again with the new settings
	self:Enable()
end

----------------------------------------------
function core:MySlashProcessorFunc(input)	--
-- /da function brings up the UI options.	--
----------------------------------------------
	InterfaceOptionsFrame_OpenToCategory_(coreOpts)
end


--~ local AceGUI = LibStub("AceGUI-3.0")


--~ local timers = {}

myTotems = {}

function abc(dir)--	/run TR.abc(90)
	local cC, cZ, cX, cY = Astrolabe:GetCurrentPlayerPosition()
	
	print("a", cX, cY)
	
	local posX, posY = GetPlayerMapPosition("player");
	print("b", posX, posY)
end




--[[
	math.deg(GetPlayerFacing())
	North = 0/360
	West = 90
	South = 180
	East = 270

	
	Totems drop
	
	Air SW, Water SE
	
	#1 = 45deg (NW)	fire
	#2 = 315deg (NE)	earth
	#3 = 135deg (SE)	water
	#4 = 225deg (SW)	air
	

]]





--~ function GetZoneData()
--~ 	local zoneData = WorldMapSize[c1];
--~ 	if ( z1 ~= 0 ) then
--~ 		zoneData = zoneData[z1];
--~ 	end
--~ 	xDelta = (x2 - x1) * zoneData.width;
--~ 	yDelta = (y2 - y1) * zoneData.height;
--~ end
local missingTotemRange = {}
function core:PLAYER_TOTEM_UPDATE(event, ...)
	local totemSlot = ...
	local haveTotem, totemName, startTime, duration = GetTotemInfo_(totemSlot)

		for name, data in pairs_(myTotems) do 
			if select_(2, GetTotemInfo_(data.totemSlot)) ~= name then
				data.icon:Hide()
			end
		end

--~ 	
--~ 	test03()
	if totemName and totemName ~= "" then
		local range = ranges[totemName] or 30
		
		if not ranges[totemName] then
			if not missingTotemRange[totemName] then
				missingTotemRange[totemName] = true
				echo("Missing totem range for "..totemName..". Please leave comment on Totem Radius page.")
			end
		end
		
--~ 		local radius = minimapSize.outdoor[Minimap:GetZoom()]
		local radius = minimapSize[indoors and "indoor" or "outdoor"][Minimap_:GetZoom()]
		
		
		local minimapWidth = Minimap_:GetWidth()
		local size = (minimapWidth * range/radius)
	
		if not myTotems[totemName] then
			-- Add a entry into our myTotems table with all all our totem's data in it.
			myTotems[totemName] = {
				icon = CreateFrame_("Button",nil,Minimap_),
				range = range,
				totemSlot = totemSlot,
				buff = totemName:sub(1,totemName:len()-6),
			}
			myTotems[totemName].icon.totem = myTotems[totemName] --Add our totem table to the icon frame so it can be used in the OnUpdate script.
			
			myTotems[totemName].icon.lastUpdate = 0
			
			myTotems[totemName].icon.lastDist = 0
			myTotems[totemName].icon:SetScript("OnUpdate", function(self, elapsed)
				self.lastUpdate = self.lastUpdate + elapsed
				if self.lastUpdate > 0.1 then
					self.lastUpdate = 0
					
					local cC, cZ, cX, cY = Astrolabe:GetCurrentPlayerPosition()
					local pC, pZ, pX, pY = unpack_(self.totem.coords)
					local dist = Astrolabe:ComputeDistance(  pC, pZ, pX, pY, cC, cZ, cX, cY )
--~ 					local hasBuff = UnitBuff("player", self.totem.buff)
					if dist < self.totem.range then --hasBuff and 
						self.outlineTexture:SetVertexColor(0, 1, 0);
					else
						if dist > self.totem.range then
							self.outlineTexture:SetVertexColor(1, 0, 0);
						else
							self.outlineTexture:SetVertexColor(0, 1, 0);
						end
						
					end

					if Astrolabe:IsIconOnEdge(self) then
						if Astrolabe:GetDistanceToIcon( self ) < P.minimapIconRange then
							self:SetAlpha(1)
						else
							self:SetAlpha(0)
						end
					else
						self:SetAlpha(1)
					end
				end
			end)
			
			
			
			myTotems[totemName].icon:SetWidth(P.iconSize)
			myTotems[totemName].icon:SetHeight(P.iconSize)

			
			myTotems[totemName].icon.spellTexture = myTotems[totemName].icon:CreateTexture(nil,"ARTWORK")
			myTotems[totemName].icon.spellTexture:SetTexture(GetSpellTexture(totemName))
			myTotems[totemName].icon.spellTexture:SetAllPoints(myTotems[totemName].icon)

--~ 			myTotems[totemName].icon.spellTexture:SetPoint("CENTER", myTotems[totemName].icon);
--~ 			myTotems[totemName].icon.spellTexture:SetWidth(16)
--~ 			myTotems[totemName].icon.spellTexture:SetHeight(16)

			myTotems[totemName].icon.solidTexture = myTotems[totemName].icon:CreateTexture(nil,"BACKGROUND")
			myTotems[totemName].icon.solidTexture:SetTexture("Interface\\AddOns\\TotemRadius\\texture\\Solid")
			myTotems[totemName].icon.solidTexture:SetPoint("CENTER", myTotems[totemName].icon);
			myTotems[totemName].icon.solidTexture:SetAlpha(0.3)
			
			myTotems[totemName].icon.outlineTexture = myTotems[totemName].icon:CreateTexture(nil,"BACKGROUND")
			myTotems[totemName].icon.outlineTexture:SetTexture("Interface\\AddOns\\TotemRadius\\texture\\Outline")
			myTotems[totemName].icon.outlineTexture:SetPoint("CENTER", myTotems[totemName].icon);
			myTotems[totemName].icon.outlineTexture:SetAlpha(1)
			
			myTotems[totemName].icon.solidTexture:SetVertexColor(P.totemColour[totemSlot].r, P.totemColour[totemSlot].g, P.totemColour[totemSlot].b, P.totemColour[totemSlot].a);
			myTotems[totemName].icon.outlineTexture:SetVertexColor(0, 1, 0, 1); --first drop, colour it green.

		end
		


		myTotems[totemName].icon.solidTexture:SetWidth(size) -- Set these to whatever height/width is needed 
		myTotems[totemName].icon.solidTexture:SetHeight(size) -- for your Texture
		
		myTotems[totemName].icon.outlineTexture:SetWidth(size) -- Set these to whatever height/width is needed 
		myTotems[totemName].icon.outlineTexture:SetHeight(size) -- for your Texture
		
		
		
		local pC, pZ = Astrolabe:GetCurrentPlayerPosition()
		
		local pX, pY = GetTotemCoords(totemHeadings[totemSlot])
		
--~ 		Debug("new totem", totemSlot, totemHeadings[totemSlot], pX, pY, AngleToCoords(pX, pY))
		myTotems[totemName].coords = {pC, pZ, pX, pY}
	
		local result = Astrolabe:PlaceIconOnMinimap( myTotems[totemName].icon, pC, pZ, pX, pY )
		myTotems[totemName].icon:Show()
	end
end


local indoors
function core:MINIMAP_UPDATE_ZOOM(event, ...)
	local zoom = Minimap_:GetZoom()
	indoors = GetCVar_("minimapZoom")+0 ~= zoom

	local range, size
	local radius = minimapSize[indoors and "indoor" or "outdoor"][Minimap_:GetZoom()]
	local minimapWidth = Minimap_:GetWidth()
	for name, data in pairs_(myTotems) do 
		size = (minimapWidth * data.range/radius)
		data.icon.solidTexture:SetWidth(size) -- Set these to whatever height/width is needed 
		data.icon.solidTexture:SetHeight(size) -- for your Texture
		
		data.icon.outlineTexture:SetWidth(size) -- Set these to whatever height/width is needed 
		data.icon.outlineTexture:SetHeight(size) -- for your Texture
		
--~ 		Debug(event, name, size)
	end
end

function core:Minimap_SetZoom(...)
	core:MINIMAP_UPDATE_ZOOM("MINIMAP_UPDATE_ZOOM")
end
--~ function core:TotemTimer()
--~ 	if testFrame then
--~ 		local cC, cZ, cX, cY = Astrolabe:GetCurrentPlayerPosition()
--~ 		local pC, pZ, pX, pY = unpack_(lastTotem)
--~ 		local dist = Astrolabe:ComputeDistance(  pC, pZ, pX, pY, cC, cZ, cX, cY )
--~ 		if dist > 3 then
--~ 			dist = dist-3
--~ 		end
--~ 		testFrame:SetText(dist)
--~ 	else
--~ 		test02()
--~ 	end
--~ end

minimapSize = { -- radius of minimap
	indoor = {
		[0] = 150,
		[1] = 120,
		[2] = 90,
		[3] = 60,
		[4] = 40,
		[5] = 25,
	},
	outdoor = {
		[0] = 233 + 1/3,
		[1] = 200,
		[2] = 166 + 2/3,
		[3] = 133 + 1/6,
		[4] = 100,
		[5] = 66 + 2/3,
	},
}

--~ Debug("x",Astrolabe:GetDistanceToIcon( data.icon ))




function OnEdgeChanged(...)
	for name, data in pairs_(myTotems) do 
		if(Astrolabe:IsIconOnEdge(data.icon)) then

			data.icon.solidTexture:SetAlpha(0)
			data.icon.outlineTexture:SetAlpha(0)
		else
			data.icon.solidTexture:SetAlpha(P.totemColour[data.totemSlot].a)
			data.icon.outlineTexture:SetAlpha(1)
			data.icon:SetAlpha(1)
--~ 			data.icon:Show()
		end
	end
end
Astrolabe:Register_OnEdgeChanged_Callback( OnEdgeChanged, "xyz" )
