local  _, class  = UnitClass('player')
if class ~= 'SHAMAN' then
	return
end


-- globals
local tostring_ = tostring
local getn = table.getn
local math_floor = math.floor
local math_abs = math.abs
local math_sin								= math.sin
local math_cos								= math.cos
local math_rad								= math.rad
local GetPlayerFacing_						= GetPlayerFacing

-- Isolate the environment
local folder, core = ...
setfenv(1, core)
-- local

local totemSpawnDistance = 3
--~ local whiteText			= "|cffffffff%s|r"
local strDebugFrom		= "|cffffff00[%s]|r" --Yellow function name. help pinpoint where the debug msg is from.
local strWhiteBar		= "|cffffff00 || |r" -- a white bar to seperate the debug info.
-----------------------------
function Debug(from, ...)	--
-- simple print function.	--
------------------------------
	if version ~= "" then--version's from curse, user doesn't need to see debug msgs.
		return
	end
	local tbl  = {...}
	local msg = tostring_(tbl[1])
	for i=2,getn(tbl) do 
		msg = msg..strWhiteBar..tostring_(tbl[i])
	end
	echo(strDebugFrom:format(from).." "..msg)
end

local colouredName		= "|cff7f7f7f{|r|cffff0000TR|r|cff7f7f7f}|r "
function echo(...)
	local tbl  = {...}
	local msg = tostring_(tbl[1])
	for i=2,getn(tbl) do 
		msg = msg..strWhiteBar..tostring_(tbl[i])
	end
	
	local cf = _G["ChatFrame1"]
	if cf then
		cf:AddMessage(colouredName..msg,.7,.7,.7)
	end
end

------------------------------------------------------------------
function Round(num, zeros)										--
-- zeroes is the number of decimal places. eg 1=*.*, 3=*.***	--
------------------------------------------------------------------
	return math_floor( num * 10 ^ (zeros or 0) + 0.5 ) / 10 ^ (zeros or 0)
end

----------------------------------------------------------------------------------
function SwitchEW(angle)														--
-- For some reason RotateTexture() function mirrors the east/west directions.	--
-- So if you're facing east it'll point west. 									--
-- This function switchs east and west directions.								--
----------------------------------------------------------------------------------
	local z = 0 - angle;
	local t = 0 - math_abs(z);
	if t < 0 then
		t = t + 360;
	end
	return t
end

function GetZoneSize()--	/run TR.GetZoneData()
	local cC, cZ = Astrolabe:GetCurrentPlayerPosition()
	local _, width, height = Astrolabe:ComputeDistance(  cC, cZ, 0, 0, cC, cZ, 1, 1 )
	return width, height
end

function GetMyYardCoords()
	local cC, cZ, cX, cY = Astrolabe:GetCurrentPlayerPosition()
	local dist, x ,y = Astrolabe:ComputeDistance(  cC, cZ, 0, 0, cC, cZ, cX, cY )
	return x, y
end

function MyHeading()
	return math.deg(GetPlayerFacing_())
end


function GetTotemCoords(direction)
	local x, y = GetMyYardCoords()
	local heading = MyHeading() + direction
	if (heading < 0) then
		heading = heading + 360;
	elseif heading > 360 then
		heading = heading - 360;
	end
	local tX, tY = GetDirectionCoords(x, y, heading, totemSpawnDistance)
	
	local cX, cY = YardCoordsToMapCoords(tX, tY)
	
	local dX, dY = tX - x, tY - y
	
--~ 	Debug("GetTotemCoords 2", "Us: "..Round(x)..","..Round(y),"T: "..Round(tX)..","..Round(tY), "D: "..Round(dX)..","..Round(dY))
--~ 	Debug("GetTotemCoords", MyHeading(), direction, heading, AngleToCoords(tX, tY, x, y), AngleToCoords(cX, cY))
	
	return cX, cY
end

----------------------------------------------------------------------------------
function SwitchEW(angle)														--
-- This function switchs east and west directions.								--
----------------------------------------------------------------------------------
	local z = 0 - angle;
	local t = 0 - math_abs(z);
	if t < 0 then
		t = t + 360;
	end
	return t
end



function GetDirectionCoords(mX, mY, direction, distance)
	local direction = direction + 90 -- cos & sin see 360/0deg at east, but GetPlayerFacing sees it at north.
	local direction = SwitchEW(direction) --This seems to work, I don't know why.
	local rad = math_rad(direction)
	local tX = mX + distance * math_cos(rad)
	local tY = mY + distance * math_sin(rad)
	return tX, tY
end

function YardCoordsToMapCoords(sX, sY)
	local width, height = GetZoneSize()
	local tX = sX / width
	local tY = sY / height
	return tX, tY
end

--~ --------------------------------------------------------------
--~ function AngleToCoords(tX, tY, sX, sY)								--
--~ -- Returns the angle to a set of coords in degrees (0-360).	--
--~ --------------------------------------------------------------
--~ 	if not sX then
--~ 		sX,sY	= GetPlayerMapPosition_("player");
--~ 	end
--~ 	local dX 		= tX - sX;
--~ 	local dY		= sY - tY;
--~ 	local heading = math_deg(math_atan2(dX , dY));
--~ 	
--~ 	
--~ 	if (heading < 0) then
--~ 		heading = heading + 360;
--~ 	elseif heading > 360 then
--~ 		heading = heading - 360;
--~ 	end
--~ 	
--~ 	heading = Round(heading,2);
--~ 	return heading;
--~ end